libstdc++: std::multiset< _Key, _Compare, _Alloc > Class Template Reference

libstdc++

std::multiset< _Key, _Compare, _Alloc > Class Template Reference
Containers » Associative

`#include <set>`

## Public Types
typedef _Alloc | allocator_type
typedef _Rep_type::const_iterator | const_iterator
typedef _Alloc_traits::const_pointer | const_pointer
typedef _Alloc_traits::const_reference | const_reference
typedef _Rep_type::const_reverse_iterator | const_reverse_iterator
typedef _Rep_type::difference_type | difference_type
typedef _Rep_type::const_iterator | iterator
typedef _Compare | key_compare
typedef _Key | key_type
typedef _Alloc_traits::pointer | pointer
typedef _Alloc_traits::reference | reference
typedef _Rep_type::const_reverse_iterator | reverse_iterator
typedef _Rep_type::size_type | size_type
typedef _Compare | value_compare
typedef _Key | value_type

## Public Member Functions
| multiset ()=default
template<typename _InputIterator>
| multiset (_InputIterator __first, _InputIterator __last)
template<typename _InputIterator>
| multiset (_InputIterator __first, _InputIterator __last, const _Compare &__comp, const allocator_type &__a=allocator_type())
template<typename _InputIterator>
| multiset (_InputIterator __first, _InputIterator __last, const allocator_type &__a)
| multiset (const _Compare &__comp, const allocator_type &__a=allocator_type())
| multiset (const allocator_type &__a)
| multiset (const multiset &)=default
| multiset (const multiset &__m, const __type_identity_t< allocator_type > &__a)
| multiset (initializer_list< value_type > __l, const _Compare &__comp=_Compare(), const allocator_type &__a=allocator_type())
| multiset (initializer_list< value_type > __l, const allocator_type &__a)
| multiset (multiset &&)=default
| multiset (multiset &&__m, const __type_identity_t< allocator_type > &__a) noexcept(is_nothrow_copy_constructible< _Compare >::value &&_Alloc_traits::_S_always_equal())
| ~multiset ()=default
iterator | begin () const noexcept
iterator | cbegin () const noexcept
iterator | cend () const noexcept
void | clear () noexcept
reverse_iterator | crbegin () const noexcept
reverse_iterator | crend () const noexcept
template<typename... _Args>
iterator | emplace (_Args &&... __args)
template<typename... _Args>
iterator | emplace_hint (const_iterator __pos, _Args &&... __args)
bool | empty () const noexcept
iterator | end () const noexcept
size_type | erase (const key_type &__x)
iterator | erase (const_iterator __first, const_iterator __last)
iterator | erase (const_iterator __position)
allocator_type | get_allocator () const noexcept
template<typename _InputIterator>
void | insert (_InputIterator __first, _InputIterator __last)
iterator | insert (const value_type &__x)
iterator | insert (const_iterator __position, const value_type &__x)
iterator | insert (const_iterator __position, value_type &&__x)
void | insert (initializer_list< value_type > __l)
iterator | insert (value_type &&__x)
key_compare | key_comp () const
size_type | max_size () const noexcept
multiset & | operator= (const multiset &)=default
multiset & | operator= (initializer_list< value_type > __l)
multiset & | operator= (multiset &&)=default
reverse_iterator | rbegin () const noexcept
reverse_iterator | rend () const noexcept
size_type | size () const noexcept
void | swap (multiset &__x) noexcept(/*conditional */)
value_compare | value_comp () const
size_type | count (const key_type &__x) const
bool | contains (const key_type &__x) const
template<typename _Kt>
auto | contains (const _Kt &__x) const -> decltype(_M_t._M_find_tr(__x), void(), true)
iterator | find (const key_type &__x)
const_iterator | find (const key_type &__x) const
iterator | lower_bound (const key_type &__x)
const_iterator | lower_bound (const key_type &__x) const
iterator | upper_bound (const key_type &__x)
const_iterator | upper_bound (const key_type &__x) const
std::pair< iterator, iterator > | equal_range (const key_type &__x)
std::pair< const_iterator, const_iterator > | equal_range (const key_type &__x) const

## Friends
template<typename _K1, typename _C1, typename _A1>
bool | operator< (const multiset< _K1, _C1, _A1 > &, const multiset< _K1, _C1, _A1 > &)
template<typename _K1, typename _C1, typename _A1>
bool | operator== (const multiset< _K1, _C1, _A1 > &, const multiset< _K1, _C1, _A1 > &)

## Detailed Description

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>
class std::multiset< _Key, _Compare, _Alloc >

A standard container made up of elements, which can be retrieved in logarithmic time.

Since
  C++98

Template Parameters

  _Key | Type of key objects.
  _Compare | Comparison function object type, defaults to less<_Key>.
  _Alloc | Allocator type, defaults to allocator<_Key>.

Meets the requirements of a container, a reversible container, and an associative container (using equivalent keys). For a `multiset<Key>` the key_type and value_type are Key.

Multisets support bidirectional iterators.

The private tree data is declared exactly the same way for set and multiset; the distinction is made entirely in how the tree functions are called (*_unique versus *_equal, same as the standard).

Definition at line 101 of file stl_multiset.h.

## Member Typedef Documentation

## ◆ allocator_type

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

typedef _Alloc std::multiset< _Key, _Compare, _Alloc >::allocator_type

Definition at line 129 of file stl_multiset.h.

## ◆ const_iterator

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

typedef _Rep_type::const_iterator std::multiset< _Key, _Compare, _Alloc >::const_iterator

Definition at line 152 of file stl_multiset.h.

## ◆ const_pointer

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

typedef _Alloc_traits::const_pointer std::multiset< _Key, _Compare, _Alloc >::const_pointer

Definition at line 145 of file stl_multiset.h.

## ◆ const_reference

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

typedef _Alloc_traits::const_reference std::multiset< _Key, _Compare, _Alloc >::const_reference

Definition at line 147 of file stl_multiset.h.

## ◆ const_reverse_iterator

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

typedef _Rep_type::const_reverse_iterator std::multiset< _Key, _Compare, _Alloc >::const_reverse_iterator

Definition at line 154 of file stl_multiset.h.

## ◆ difference_type

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

typedef _Rep_type::difference_type std::multiset< _Key, _Compare, _Alloc >::difference_type

Definition at line 156 of file stl_multiset.h.

## ◆ iterator

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

typedef _Rep_type::const_iterator std::multiset< _Key, _Compare, _Alloc >::iterator

Definition at line 151 of file stl_multiset.h.

## ◆ key_compare

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

typedef _Compare std::multiset< _Key, _Compare, _Alloc >::key_compare

Definition at line 127 of file stl_multiset.h.

## ◆ key_type

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

typedef _Key std::multiset< _Key, _Compare, _Alloc >::key_type

Definition at line 125 of file stl_multiset.h.

## ◆ pointer

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

typedef _Alloc_traits::pointer std::multiset< _Key, _Compare, _Alloc >::pointer

Definition at line 144 of file stl_multiset.h.

## ◆ reference

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

typedef _Alloc_traits::reference std::multiset< _Key, _Compare, _Alloc >::reference

Definition at line 146 of file stl_multiset.h.

## ◆ reverse_iterator

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

typedef _Rep_type::const_reverse_iterator std::multiset< _Key, _Compare, _Alloc >::reverse_iterator

Definition at line 153 of file stl_multiset.h.

## ◆ size_type

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

typedef _Rep_type::size_type std::multiset< _Key, _Compare, _Alloc >::size_type

Definition at line 155 of file stl_multiset.h.

## ◆ value_compare

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

typedef _Compare std::multiset< _Key, _Compare, _Alloc >::value_compare

Definition at line 128 of file stl_multiset.h.

## ◆ value_type

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

typedef _Key std::multiset< _Key, _Compare, _Alloc >::value_type

Definition at line 126 of file stl_multiset.h.

## Constructor & Destructor Documentation

## ◆ multiset() [1/12]

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

std::multiset< _Key, _Compare, _Alloc >::multiset | ( |  | ) |
| default

Default constructor creates no elements.

## ◆ multiset() [2/12]

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

std::multiset< _Key, _Compare, _Alloc >::multiset | ( | const _Compare & | __comp,
|  | const allocator_type & | __a = allocator_type() )
| inlineexplicit

Creates a multiset with no elements.

Parameters

  __comp | Comparator to use.
  __a | An allocator object.

Definition at line 178 of file stl_multiset.h.

## ◆ multiset() [3/12]

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>
template<typename _InputIterator>

std::multiset< _Key, _Compare, _Alloc >::multiset | ( | _InputIterator | __first,
|  | _InputIterator | __last )
| inline

Builds a multiset from a range.

Parameters

  __first | An input iterator.
  __last | An input iterator.

Create a multiset consisting of copies of the elements from [first,last). This is linear in N if the range is already sorted, and NlogN otherwise (where N is distance(__first,__last)).

Definition at line 192 of file stl_multiset.h.

## ◆ multiset() [4/12]

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>
template<typename _InputIterator>

std::multiset< _Key, _Compare, _Alloc >::multiset | ( | _InputIterator | __first,
|  | _InputIterator | __last,
|  | const _Compare & | __comp,
|  | const allocator_type & | __a = allocator_type() )
| inline

Builds a multiset from a range.

Parameters

  __first | An input iterator.
  __last | An input iterator.
  __comp | A comparison functor.
  __a | An allocator object.

Create a multiset consisting of copies of the elements from [__first,__last). This is linear in N if the range is already sorted, and NlogN otherwise (where N is distance(__first,__last)).

Definition at line 208 of file stl_multiset.h.

## ◆ multiset() [5/12]

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

std::multiset< _Key, _Compare, _Alloc >::multiset | ( | const multiset< _Key, _Compare, _Alloc > & |  | ) |
| default

Multiset copy constructor.

Whether the allocator is copied depends on the allocator traits.

## ◆ multiset() [6/12]

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

std::multiset< _Key, _Compare, _Alloc >::multiset | ( | multiset< _Key, _Compare, _Alloc > && |  | ) |
| default

Multiset move constructor.

The newly-created multiset contains the exact contents of the moved instance. The moved instance is a valid, but unspecified multiset.

## ◆ multiset() [7/12]

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

std::multiset< _Key, _Compare, _Alloc >::multiset | ( | initializer_list< value_type > | __l,
|  | const _Compare & | __comp = _Compare(),
|  | const allocator_type & | __a = allocator_type() )
| inline

Builds a multiset from an initializer_list.

Parameters

  __l | An initializer_list.
  __comp | A comparison functor.
  __a | An allocator object.

Create a multiset consisting of copies of the elements from the list. This is linear in N if the list is already sorted, and NlogN otherwise (where N is __l.size()).

Definition at line 244 of file stl_multiset.h.

## ◆ multiset() [8/12]

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

std::multiset< _Key, _Compare, _Alloc >::multiset | ( | const allocator_type & | __a | ) |
| inlineexplicit

Allocator-extended default constructor.

Definition at line 252 of file stl_multiset.h.

## ◆ multiset() [9/12]

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

std::multiset< _Key, _Compare, _Alloc >::multiset | ( | const multiset< _Key, _Compare, _Alloc > & | __m,
|  | const __type_identity_t< allocator_type > & | __a )
| inline

Allocator-extended copy constructor.

Definition at line 256 of file stl_multiset.h.

## ◆ multiset() [10/12]

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

std::multiset< _Key, _Compare, _Alloc >::multiset | ( | multiset< _Key, _Compare, _Alloc > && | __m,
|  | const __type_identity_t< allocator_type > & | __a )
| inlinenoexcept

Allocator-extended move constructor.

Definition at line 261 of file stl_multiset.h.

## ◆ multiset() [11/12]

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

std::multiset< _Key, _Compare, _Alloc >::multiset | ( | initializer_list< value_type > | __l,
|  | const allocator_type & | __a )
| inline

Allocator-extended initialier-list constructor.

Definition at line 267 of file stl_multiset.h.

## ◆ multiset() [12/12]

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>
template<typename _InputIterator>

std::multiset< _Key, _Compare, _Alloc >::multiset | ( | _InputIterator | __first,
|  | _InputIterator | __last,
|  | const allocator_type & | __a )
| inline

Allocator-extended range constructor.

Definition at line 273 of file stl_multiset.h.

## ◆ ~multiset()

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

std::multiset< _Key, _Compare, _Alloc >::~multiset | ( |  | ) |
| default

The dtor only erases the elements, and note that if the elements themselves are pointers, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibility.

## Member Function Documentation

## ◆ begin()

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

iterator std::multiset< _Key, _Compare, _Alloc >::begin | ( |  | ) | const
| inlinenoexcept

Returns a read-only (constant) iterator that points to the first element in the multiset. Iteration is done in ascending order according to the keys.

Definition at line 365 of file stl_multiset.h.

## ◆ cbegin()

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

iterator std::multiset< _Key, _Compare, _Alloc >::cbegin | ( |  | ) | const
| inlinenoexcept

Returns a read-only (constant) iterator that points to the first element in the multiset. Iteration is done in ascending order according to the keys.

Definition at line 402 of file stl_multiset.h.

## ◆ cend()

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

iterator std::multiset< _Key, _Compare, _Alloc >::cend | ( |  | ) | const
| inlinenoexcept

Returns a read-only (constant) iterator that points one past the last element in the multiset. Iteration is done in ascending order according to the keys.

Definition at line 411 of file stl_multiset.h.

## ◆ clear()

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

void std::multiset< _Key, _Compare, _Alloc >::clear | ( |  | ) |
| inlinenoexcept

Erases all elements in a multiset. Note that this function only erases the elements, and that if the elements themselves are pointers, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibility.

Definition at line 776 of file stl_multiset.h.

## ◆ contains() [1/2]

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>
template<typename _Kt>

auto std::multiset< _Key, _Compare, _Alloc >::contains | ( | const _Kt & | __x | ) | const -> decltype(_M_t._M_find_tr(__x), void(), true)
| inline

Finds whether an element with the given key exists.

Parameters

  __x | Key of elements to be located.

Returns
  True if there is any element with the specified key.

Definition at line 812 of file stl_multiset.h.

## ◆ contains() [2/2]

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

bool std::multiset< _Key, _Compare, _Alloc >::contains | ( | const key_type & | __x | ) | const
| inline

Finds whether an element with the given key exists.

Parameters

  __x | Key of elements to be located.

Returns
  True if there is any element with the specified key.

Definition at line 807 of file stl_multiset.h.

## ◆ count()

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

size_type std::multiset< _Key, _Compare, _Alloc >::count | ( | const key_type & | __x | ) | const
| inline

Finds the number of elements with given key.

Parameters

  __x | Key of elements to be located.

Returns
  Number of elements with specified key.

Definition at line 788 of file stl_multiset.h.

## ◆ crbegin()

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

reverse_iterator std::multiset< _Key, _Compare, _Alloc >::crbegin | ( |  | ) | const
| inlinenoexcept

Returns a read-only (constant) reverse iterator that points to the last element in the multiset. Iteration is done in descending order according to the keys.

Definition at line 420 of file stl_multiset.h.

## ◆ crend()

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

reverse_iterator std::multiset< _Key, _Compare, _Alloc >::crend | ( |  | ) | const
| inlinenoexcept

Returns a read-only (constant) reverse iterator that points to the last element in the multiset. Iteration is done in descending order according to the keys.

Definition at line 429 of file stl_multiset.h.

## ◆ emplace()

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>
template<typename... _Args>

iterator std::multiset< _Key, _Compare, _Alloc >::emplace | ( | _Args &&... | __args | ) |
| inline

Builds and inserts an element into the multiset.

Parameters

  __args | Arguments used to generate the element instance to be inserted.

Returns
  An iterator that points to the inserted element.

This function inserts an element into the multiset. Contrary to a std::set the multiset does not rely on unique keys and thus multiple copies of the same element can be inserted.

Insertion requires logarithmic time.

Definition at line 482 of file stl_multiset.h.

## ◆ emplace_hint()

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>
template<typename... _Args>

iterator std::multiset< _Key, _Compare, _Alloc >::emplace_hint | ( | const_iterator | __pos,
|  | _Args &&... | __args )
| inline

Builds and inserts an element into the multiset.

Parameters

  __pos | An iterator that serves as a hint as to where the element should be inserted.
  __args | Arguments used to generate the element instance to be inserted.

Returns
  An iterator that points to the inserted element.

This function inserts an element into the multiset. Contrary to a std::set the multiset does not rely on unique keys and thus multiple copies of the same element can be inserted.

Note that the first parameter is only a hint and can potentially improve the performance of the insertion process. A bad hint would cause no gains in efficiency.

See https://gcc.gnu.org/onlinedocs/libstdc++/manual/associative.html#containers.associative.insert_hints for more on hinting.

Insertion requires logarithmic time (if the hint is not taken).

Definition at line 508 of file stl_multiset.h.

## ◆ empty()

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

bool std::multiset< _Key, _Compare, _Alloc >::empty | ( |  | ) | const
| inlinenodiscardnoexcept

Returns true if the set is empty.

Definition at line 435 of file stl_multiset.h.

## ◆ end()

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

iterator std::multiset< _Key, _Compare, _Alloc >::end | ( |  | ) | const
| inlinenoexcept

Returns a read-only (constant) iterator that points one past the last element in the multiset. Iteration is done in ascending order according to the keys.

Definition at line 374 of file stl_multiset.h.

## ◆ equal_range() [1/2]

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

std::pair< iterator, iterator > std::multiset< _Key, _Compare, _Alloc >::equal_range | ( | const key_type & | __x | ) |
| inline

Finds a subsequence matching given key.

Parameters

  __x | Key to be located.

Returns
  Pair of iterators that possibly points to the subsequence matching given key.

This function is equivalent to

std::make_pair(c.lower_bound(val),
c.upper_bound(val))
std::make_pair
constexpr pair< typename __decay_and_strip< _T1 >::__type, typename __decay_and_strip< _T2 >::__type > make_pair(_T1 &&__x, _T2 &&__y)
A convenience wrapper for creating a pair from two objects.
Definition stl_pair.h:1169

(but is faster than making the calls separately).

This function probably only makes sense for multisets.

Definition at line 937 of file stl_multiset.h.

## ◆ equal_range() [2/2]

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

std::pair< const_iterator, const_iterator > std::multiset< _Key, _Compare, _Alloc >::equal_range | ( | const key_type & | __x | ) | const
| inline

Finds a subsequence matching given key.

Parameters

  __x | Key to be located.

Returns
  Pair of iterators that possibly points to the subsequence matching given key.

This function is equivalent to

std::make_pair(c.lower_bound(val),
c.upper_bound(val))

(but is faster than making the calls separately).

This function probably only makes sense for multisets.

Definition at line 941 of file stl_multiset.h.

## ◆ erase() [1/3]

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

size_type std::multiset< _Key, _Compare, _Alloc >::erase | ( | const key_type & | __x | ) |
| inline

Erases elements according to the provided key.

Parameters

  __x | Key of element to be erased.

Returns
  The number of elements erased.

This function erases all elements located by the given key from a multiset. Note that this function only erases the element, and that if the element is itself a pointer, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibility.

Definition at line 720 of file stl_multiset.h.

## ◆ erase() [2/3]

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

iterator std::multiset< _Key, _Compare, _Alloc >::erase | ( | const_iterator | __first,
|  | const_iterator | __last )
| inline

Erases a [first,last) range of elements from a multiset.

Parameters

  __first | Iterator pointing to the start of the range to be erased.
  __last | Iterator pointing to the end of the range to be erased.

Returns
  The iterator last.

This function erases a sequence of elements from a multiset. Note that this function only erases the elements, and that if the elements themselves are pointers, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibility.

Definition at line 749 of file stl_multiset.h.

## ◆ erase() [3/3]

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

iterator std::multiset< _Key, _Compare, _Alloc >::erase | ( | const_iterator | __position | ) |
| inline

Erases an element from a multiset.

Parameters

  __position | An iterator pointing to the element to be erased.

Returns
  An iterator pointing to the element immediately following position prior to the element being erased. If no such element exists, end() is returned.

This function erases an element, pointed to by the given iterator, from a multiset. Note that this function only erases the element, and that if the element is itself a pointer, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibility.

Definition at line 690 of file stl_multiset.h.

## ◆ find() [1/2]

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

iterator std::multiset< _Key, _Compare, _Alloc >::find | ( | const key_type & | __x | ) |
| inline

Tries to locate an element in a set.

Parameters

  __x | Element to be located.

Returns
  Iterator pointing to sought-after element, or end() if not found.

This function takes a key and tries to locate the element with which the key matches. If successful the function returns an iterator pointing to the sought after element. If unsuccessful it returns the past-the-end ( `end()` ) iterator.

Definition at line 833 of file stl_multiset.h.

## ◆ find() [2/2]

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

const_iterator std::multiset< _Key, _Compare, _Alloc >::find | ( | const key_type & | __x | ) | const
| inline

Tries to locate an element in a set.

Parameters

  __x | Element to be located.

Returns
  Iterator pointing to sought-after element, or end() if not found.

This function takes a key and tries to locate the element with which the key matches. If successful the function returns an iterator pointing to the sought after element. If unsuccessful it returns the past-the-end ( `end()` ) iterator.

Definition at line 837 of file stl_multiset.h.

## ◆ get_allocator()

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

allocator_type std::multiset< _Key, _Compare, _Alloc >::get_allocator | ( |  | ) | const
| inlinenoexcept

Returns the memory allocation object.

Definition at line 356 of file stl_multiset.h.

## ◆ insert() [1/6]

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>
template<typename _InputIterator>

void std::multiset< _Key, _Compare, _Alloc >::insert | ( | _InputIterator | __first,
|  | _InputIterator | __last )
| inline

A template function that tries to insert a range of elements.

Parameters

  __first | Iterator pointing to the start of the range to be inserted.
  __last | Iterator pointing to the end of the range.

Complexity similar to that of the range constructor.

Definition at line 576 of file stl_multiset.h.

## ◆ insert() [2/6]

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

iterator std::multiset< _Key, _Compare, _Alloc >::insert | ( | const value_type & | __x | ) |
| inline

Inserts an element into the multiset.

Parameters

  __x | Element to be inserted.

Returns
  An iterator that points to the inserted element.

This function inserts an element into the multiset. Contrary to a std::set the multiset does not rely on unique keys and thus multiple copies of the same element can be inserted.

Insertion requires logarithmic time.

Definition at line 527 of file stl_multiset.h.

Referenced by std::multiset< _Key, _Cmp, polymorphic_allocator< _Key > >::insert().

## ◆ insert() [3/6]

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

iterator std::multiset< _Key, _Compare, _Alloc >::insert | ( | const_iterator | __position,
|  | const value_type & | __x )
| inline

Inserts an element into the multiset.

Parameters

  __position | An iterator that serves as a hint as to where the element should be inserted.
  __x | Element to be inserted.

Returns
  An iterator that points to the inserted element.

This function inserts an element into the multiset. Contrary to a std::set the multiset does not rely on unique keys and thus multiple copies of the same element can be inserted.

Note that the first parameter is only a hint and can potentially improve the performance of the insertion process. A bad hint would cause no gains in efficiency.

See https://gcc.gnu.org/onlinedocs/libstdc++/manual/associative.html#containers.associative.insert_hints for more on hinting.

Insertion requires logarithmic time (if the hint is not taken).

Definition at line 557 of file stl_multiset.h.

## ◆ insert() [4/6]

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

iterator std::multiset< _Key, _Compare, _Alloc >::insert | ( | const_iterator | __position,
|  | value_type && | __x )
| inline

Definition at line 562 of file stl_multiset.h.

## ◆ insert() [5/6]

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

void std::multiset< _Key, _Compare, _Alloc >::insert | ( | initializer_list< value_type > | __l | ) |
| inline

Attempts to insert a list of elements into the multiset.

Parameters

  __l | A std::initializer_list<value_type> of elements to be inserted.

Complexity similar to that of the range constructor.

Definition at line 588 of file stl_multiset.h.

## ◆ insert() [6/6]

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

iterator std::multiset< _Key, _Compare, _Alloc >::insert | ( | value_type && | __x | ) |
| inline

Definition at line 532 of file stl_multiset.h.

## ◆ key_comp()

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

key_compare std::multiset< _Key, _Compare, _Alloc >::key_comp | ( |  | ) | const
| inline

Returns the comparison object.

Definition at line 348 of file stl_multiset.h.

## ◆ lower_bound() [1/2]

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

iterator std::multiset< _Key, _Compare, _Alloc >::lower_bound | ( | const key_type & | __x | ) |
| inline

Finds the beginning of a subsequence matching given key.

Parameters

  __x | Key to be located.

Returns
  Iterator pointing to first element equal to or greater than key, or end().

This function returns the first element of a subsequence of elements that matches the given key. If unsuccessful it returns an iterator pointing to the first element that has a greater value than given key or end() if no such element exists.

Definition at line 868 of file stl_multiset.h.

## ◆ lower_bound() [2/2]

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

const_iterator std::multiset< _Key, _Compare, _Alloc >::lower_bound | ( | const key_type & | __x | ) | const
| inline

Finds the beginning of a subsequence matching given key.

Parameters

  __x | Key to be located.

Returns
  Iterator pointing to first element equal to or greater than key, or end().

This function returns the first element of a subsequence of elements that matches the given key. If unsuccessful it returns an iterator pointing to the first element that has a greater value than given key or end() if no such element exists.

Definition at line 872 of file stl_multiset.h.

## ◆ max_size()

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

size_type std::multiset< _Key, _Compare, _Alloc >::max_size | ( |  | ) | const
| inlinenoexcept

Returns the maximum size of the set.

Definition at line 445 of file stl_multiset.h.

## ◆ operator=() [1/3]

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

multiset & std::multiset< _Key, _Compare, _Alloc >::operator= | ( | const multiset< _Key, _Compare, _Alloc > & |  | ) |
| default

Multiset assignment operator.

Whether the allocator is copied depends on the allocator traits.

## ◆ operator=() [2/3]

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

multiset & std::multiset< _Key, _Compare, _Alloc >::operator= | ( | initializer_list< value_type > | __l | ) |
| inline

Multiset list assignment operator.

Parameters

  __l | An initializer_list.

This function fills a multiset with copies of the elements in the initializer list __l.

Note that the assignment completely changes the multiset and that the resulting multiset's size is the same as the number of elements assigned.

Definition at line 337 of file stl_multiset.h.

## ◆ operator=() [3/3]

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

multiset & std::multiset< _Key, _Compare, _Alloc >::operator= | ( | multiset< _Key, _Compare, _Alloc > && |  | ) |
| default

Move assignment operator.

## ◆ rbegin()

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

reverse_iterator std::multiset< _Key, _Compare, _Alloc >::rbegin | ( |  | ) | const
| inlinenoexcept

Returns a read-only (constant) reverse iterator that points to the last element in the multiset. Iteration is done in descending order according to the keys.

Definition at line 383 of file stl_multiset.h.

## ◆ rend()

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

reverse_iterator std::multiset< _Key, _Compare, _Alloc >::rend | ( |  | ) | const
| inlinenoexcept

Returns a read-only (constant) reverse iterator that points to the last element in the multiset. Iteration is done in descending order according to the keys.

Definition at line 392 of file stl_multiset.h.

## ◆ size()

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

size_type std::multiset< _Key, _Compare, _Alloc >::size | ( |  | ) | const
| inlinenoexcept

Returns the size of the set.

Definition at line 440 of file stl_multiset.h.

## ◆ swap()

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

void std::multiset< _Key, _Compare, _Alloc >::swap | ( | multiset< _Key, _Compare, _Alloc > & | __x | ) |
| inlinenoexcept

Swaps data with another multiset.

Parameters

  __x | A multiset of the same element and allocator types.

This exchanges the elements between two multisets in constant time. (It is only swapping a pointer, an integer, and an instance of the `Compare` type (which itself is often stateless and empty), so it should be quite fast.) Note that the global std::swap() function is specialized such that std::swap(s1,s2) will feed to this function.

Whether the allocators are swapped depends on the allocator traits.

Definition at line 462 of file stl_multiset.h.

Referenced by std::swap().

## ◆ upper_bound() [1/2]

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

iterator std::multiset< _Key, _Compare, _Alloc >::upper_bound | ( | const key_type & | __x | ) |
| inline

Finds the end of a subsequence matching given key.

Parameters

  __x | Key to be located.

Returns
  Iterator pointing to the first element greater than key, or end().

Definition at line 898 of file stl_multiset.h.

## ◆ upper_bound() [2/2]

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

const_iterator std::multiset< _Key, _Compare, _Alloc >::upper_bound | ( | const key_type & | __x | ) | const
| inline

Finds the end of a subsequence matching given key.

Parameters

  __x | Key to be located.

Returns
  Iterator pointing to the first element greater than key, or end().

Definition at line 902 of file stl_multiset.h.

## ◆ value_comp()

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

value_compare std::multiset< _Key, _Compare, _Alloc >::value_comp | ( |  | ) | const
| inline

Returns the comparison object.

Definition at line 352 of file stl_multiset.h.

The documentation for this class was generated from the following file:

- stl_multiset.h